## nwchem 7.2.2

=== CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

cmake_minimum_required (VERSION 3.18.0 FATAL_ERROR)
project (GlobalArrays VERSION 5.8.0 LANGUAGES C)

# Append local CMake directory
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/linalg-modules")
message(STATUS "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")
include(ga-utils)

ga_option(ENABLE_CXX ON)
ga_option(ENABLE_FORTRAN ON)
ga_option(CMAKE_CXX_EXTENSIONS OFF)

set(NOFORT 1)
set(ENABLE_F77 0)

if(ENABLE_CXX)
  enable_language(CXX)
endif()

if (ENABLE_FORTRAN)
  enable_language(Fortran)
  set(NOFORT 0)
  set(ENABLE_F77 1)
endif()

ga_option(CMAKE_BUILD_TYPE Release)
ga_option(LINALG_VENDOR BLIS)
ga_option(ENABLE_TESTS ON)
ga_option(ENABLE_PROFILING OFF)
#Options for user provided LinAlg libraries
ga_option(ENABLE_BLAS OFF)
ga_option(ENABLE_SCALAPACK OFF)
ga_option(ENABLE_EISPACK OFF)
ga_option(ENABLE_DPCPP OFF)
ga_option(ENABLE_DEV_MODE OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_NO_SYSTEM_FROM_IMPORTED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
# set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

include(${PROJECT_SOURCE_DIR}/cmake/ga-compiler-options.cmake)

if(ENABLE_BLAS)
  if(NOT ENABLE_FORTRAN)
    message(FATAL_ERROR "ENABLE_BLAS=ON needs ENABLE_FORTRAN=ON")
  endif()  
endif()

if(MSVC AND ENABLE_FORTRAN)
  message(FATAL_ERROR "MSVC build needs ENABLE_FORTRAN=OFF")
endif()

if(ENABLE_PROFILING)
  if(CMAKE_C_COMPILER_ID STREQUAL "Clang" OR CMAKE_C_COMPILER_ID STREQUAL "AppleClang")
    message(FATAL_ERROR "GA profiling is currently not supported with Clang compilers. Please set ENABLE_PROFILING=OFF")
  endif()
endif()

# GA Runtime options: MPI runtime used to build GA
ga_option(GA_RUNTIME MPI_2SIDED)

if (GA_RUNTIME STREQUAL MPI_PROGRESS_RANK)
  set (MPI_PR TRUE CACHE BOOL "use MPI progress ranks protocol for communication")
elseif (GA_RUNTIME STREQUAL MPI_RMA)
  set (MPI3 TRUE CACHE BOOL "use MPI RMA protocols for communication")
elseif (GA_RUNTIME STREQUAL MPI_MULTITHREADED)
  set (MPI_MT TRUE CACHE BOOL "use MPI multi-threading protocols for communication")
elseif (GA_RUNTIME STREQUAL MPI_PROGRESS_THREAD)
  set (MPI_PT TRUE CACHE BOOL "use MPI progress thread protocols for communication")
elseif (GA_RUNTIME STREQUAL MPI_2SIDED)
  set (MPI_TS TRUE CACHE BOOL "use MPI 2-sided protocol for communication")
else()
  message(STATUS "GA_RUNTIME provided \"${GA_RUNTIME}\" is not supported")
endif()

option (MSG_COMMS_MPI "Using MPI runtime for communication" ON)
option (ENABLE_ARMCI_MEM_OPTION "User option for managing memory" ON)
option (ENABLE_CUDA_MEM "User option for CUDA memory" OFF)
option (F2C_HIDDEN_STRING_LENGTH_AFTER_ARGS "Fortran/C interface property" ON)

message(STATUS "Checking MPI ...")
find_package (MPI REQUIRED)
set(GA_EXTRA_LIBS ${GA_EXTRA_LIBS} MPI::MPI_C)
if(ENABLE_FORTRAN)
  #macos fix for clang+gfortran build
  #linking MPI::MPI_Fortran adds the flag to clang compile line
  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    get_target_property(_mpif_ico MPI::MPI_Fortran INTERFACE_COMPILE_OPTIONS)
    if(_mpif_ico)
      string(REPLACE "-fallow-argument-mismatch" "" _mpif_ico ${_mpif_ico})
      separate_arguments(_mpif_ico)
      set_target_properties(MPI::MPI_Fortran PROPERTIES INTERFACE_COMPILE_OPTIONS "${_mpif_ico}")
    endif()
  endif()
  list(APPEND GA_EXTRA_LIBS MPI::MPI_Fortran)
endif()

include(${PROJECT_SOURCE_DIR}/cmake/ga-checks.cmake)

if (ENABLE_FORTRAN)
  include( FortranCInterface )
  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h MACRO_NAMESPACE F77_FUNC_)
else()
  CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/f2c_dummy.h.in
                  ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h )
endif()

# set some flags for MS Visual C Compiler
if (MSVC)
  add_definitions(/D NOMINMAX /D _CRT_SECURE_NO_WARNINGS /D _CRT_NONSTDC_NO_WARNINGS)
endif()
   
# hardwire various GA configuration parameters. Use convention that parameters
# are defined and set to 0 if not used
set (CYGWIN 0)
set (DECOSF 0)

if (CMAKE_SYSTEM_NAME STREQUAL Linux)
  set(LINUX 1)
  set(LINUX64 1)
endif()

set(USE_I8 OFF)
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(USE_I8 ON)
  set(BLAS_SIZE 8)
endif()

option (ENABLE_I8 "Use 8 byte Fortran integers" ${USE_I8})
message(STATUS "void size: ${CMAKE_SIZEOF_VOID_P}, USE_I8: ${USE_I8}, ENABLE_I8: ${ENABLE_I8}")

include(${PROJECT_SOURCE_DIR}/cmake/ga-linalg.cmake)

# hardwire memcpy and strchr since these have been standard for years
set (HAVE_MEMCPY 1)
set (HAVE_STRCHR 1)

# miscellaneous hardwired parameters (mostly not used)
set (ENABLE_CHECKPOINT 0)
set (GA_PROFILING 0)
set (ENABLE_TRACE 0)
set (STATS 1)
set (USE_MALLOC 0)
if(ENABLE_PROFILING)
  set (GA_PROFILING 1)
endif()
if(USE_CRAYSHASTA)
  set(__CRAYXE 1)
  # list(APPEND GA_EXTRA_LIBS pmi2)
endif()

# hardwire ARMCI configuration options
set (HAVE_ARMCI_GROUP_COMM 1)
set (HAVE_ARMCI_GROUP_COMM_MEMBER 0)
set (HAVE_ARMCI_INITIALIZED 1)

# suppress any checks to see if test codes run. Only check for compilation.
# use for cross-compilation situations
option (CHECK_COMPILATION_ONLY "Check compilation only" OFF)

if (ENABLE_FORTRAN)
  message(STATUS "CMAKE_Fortran_COMPILER: ${CMAKE_Fortran_COMPILER}")
  message(STATUS "CMAKE_Fortran_COMPILER_ID: ${CMAKE_Fortran_COMPILER_ID}")
  set (F90_MODULE )
  set (F77_GETARG GETARG)
  set (F77_GETARG_ARGS "i,s")
  set (F77_GETARG_DECLS "")
  set (F77_IARGC IARGC)
  set (F77_FLUSH flush)
  set (HAVE_F77_FLUSH 1)

  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
     message(STATUS "Using GNU Fortran compiler settings")
     set (F77_GETARG_DECLS "intrinsic GETARG")
     set (FORTRAN_I8_FLAG -fdefault-integer-8)
     set (FORTRAN_I4_FLAG "")
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Flang")
     message(STATUS "Using Flang compiler settings")
     set (F77_GETARG_DECLS "external GETARG")
     set (FORTRAN_I8_FLAG -fdefault-integer-8)
     set (FORTRAN_I4_FLAG "")
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
     message(STATUS "Using Intel Fortran compiler settings")
     set (F77_GETARG_DECLS "external GETARG")
     set (FORTRAN_I8_FLAG "-i8 -integer-size 64")
     set (FORTRAN_I4_FLAG "-i4 -integer-size 32")
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
     message(STATUS "Using PGI Fortran compiler settings")
     set (FORTRAN_I8_FLAG -i8)
     set (FORTRAN_I4_FLAG -i4)
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "XL")
     message(STATUS "Using IBM XL Fortran compiler settings")
     set (FORTRAN_I8_FLAG -qintsize=8)
     set (FORTRAN_I4_FLAG -qintsize=4)
  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Fujitsu")
     message(STATUS "Fujitsu Fortran compiler settings")
     set (FORTRAN_I8_FLAG "-CcdII8 -CcdLL8")
     set (FORTRAN_I4_FLAG "")
  endif()
else()
# need to set these variable even if only compiling C/C++
   set (F77_GETARG GETARG)
   set (F77_GETARG_ARGS "i,s")
   set (F77_GETARG_DECLS "external GETARG")
   set (F77_IARGC IARGC)
   set (FORTRAN_I8_FLAG -i8)
   set (FORTRAN_I4_FLAG -i4)
endif() 

# check_fortran_compiler_flag("-fallow-argument-mismatch" _fam)
# ga_is_valid(_fam _fam_flag_exists)
# if(_fam_flag_exists)
#   set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
# endif()
if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "10.1")
    set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
  endif()
  if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "11.1")
    set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-tree-slp-vectorize")
  endif()
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  if(ENABLE_CXX) 
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
      add_compile_options(-fno-aggressive-loop-optimizations)
    endif()
  else()
    add_compile_options(-fno-aggressive-loop-optimizations)
  endif()  
elseif (CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-aggressive-loop-optimizations")
endif()

# Hardwire these settings. No way to check for Fortran integer size in CMake
# (that we can find)
set (CM_SIZEOF_F77_DOUBLE 8)
set (CM_SIZEOF_F77_REAL 4)
set (CM_SIZEOF_F77_INTEGER 4)
set (F2C_INTEGER_C_TYPE int)
set (F2C_REAL_C_TYPE float)
set (F2C_DOUBLE_PRECISION_C_TYPE double)
if (ENABLE_I8)
  set (CM_SIZEOF_F77_INTEGER 8)
  set (F2C_INTEGER_C_TYPE long)
  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${FORTRAN_I8_FLAG}")
  message(STATUS "Fortran flags: ${CMAKE_Fortran_FLAGS}")
endif()
set (C_POINTER_AS_INTEGER int)
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set (C_POINTER_AS_INTEGER long)
  if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(NOUSE_MMAP 1)
  endif()
  set(GA_FORTRAN_ACCESS_INDEX integer*8)
else()
  set(GA_FORTRAN_ACCESS_INDEX integer*4)
endif()
# set (CM_BLAS_SIZE ${CM_SIZEOF_F77_INTEGER})

# -------------------------------------------------------------
# Create include files from templates
# -------------------------------------------------------------
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/config.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/farg.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/gaf2c/farg.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/typesf2c.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/gaf2c/typesf2c.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/matypes.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/ma/matypes.h )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/mafdecls.fh.in
                ${CMAKE_CURRENT_BINARY_DIR}/ma/mafdecls.fh )
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/global.fh.in
                ${CMAKE_CURRENT_BINARY_DIR}/global/src/global.fh )

if (ENABLE_FORTRAN)
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/config.fh
    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.h" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.fh" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
  )
  add_custom_target(
    GenerateConfigFH ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.fh
  )
  set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/config.fh
    PROPERTIES GENERATED TRUE
  )
endif()

include_directories(AFTER ${MPI_INCLUDE_PATH})
add_definitions (-DHAVE_CONFIG_H -DOMPI_SKIP_MPICXX)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
list(APPEND GA_EXTRA_LIBS ${CMAKE_THREAD_LIBS_INIT})

if(NOT ENABLE_FORTRAN OR BUILD_SHARED_LIBS)
  if(NOT MSVC)
    list(APPEND GA_EXTRA_LIBS m)
  endif()
endif()

=== cmx/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GXA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

cmake_minimum_required (VERSION 2.8.8)
project (CMX)

option (CMX_RUNTIME, "Protocols using to build CMX" MPI_RMA)
option (USE_MPI_RMA "use MPI RMA protocols for communication" OFF)
option (USE_MPI_PR "use MPI progress ranks for communication" OFF)
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} src-common src-armci)
message (STATUS "CMX_RUNTIME: ${CMX_RUNTIME}")
if (CMX_RUNTIME STREQUAL "MPI_RMA")
  message(STATUS "Found MPI_RMA")
  set (USE_MPI_RMA ON)
elseif (CMX_RUNTIME STREQUAL "MPI_PR")
  message(STATUS "Found MPI_PR")
  set (USE_MPI_PR ON)
else()
  message(STATUS "Found default MPI_RMA")
  set (USE_MPI_RMA ON)
endif ()
message (STATUS "USE_MPI_RMA: ${USE_MPI_RMA}")
message (STATUS "USE_MPI_PR: ${USE_MPI_PR}")
if (USE_MPI_RMA)
  set(CMX_DEVICE
    src-mpi-rma/cmx.c
    src-mpi-rma/groups.c
  )
  set (CMX_NETWORK_MPI_RMA ON)
  include_directories(AFTER src-mpi-rma)
elseif (USE_MPI_PR)
  set(CMX_DEVICE
    src-mpi-pr/cmx.c
    src-mpi-pr/groups.c
    src-mpi-pr/reg_cache.c
  )
  set (CMX_NETWORK_MPI_PR ON)
  include_directories(AFTER src-mpi-pr)
endif()

set(ARMCI_API
  src-armci/armci.c
  src-armci/capi.c
  src-armci/groups.c
  src-armci/iterator.c
  src-armci/message.c
  src-armci/reg_entry.c
)

find_package(MPI)

add_definitions (-DHAVE_CONFIG_H=1)

# -------------------------------------------------------------
# Check for variable sizes, include files and functions
# -------------------------------------------------------------

# check size of different variables
include(CheckTypeSize)
check_type_size("int" CM_SIZEOF_INT)
check_type_size("double" CM_SIZEOF_DOUBLE)
check_type_size("float" CM_SIZEOF_FLOAT)
check_type_size("long" CM_SIZEOF_LONG)
check_type_size("long double" CM_SIZEOF_LONG_DOUBLE)
check_type_size("long long" CM_SIZEOF_LONG_LONG)
check_type_size("short" CM_SIZEOF_SHORT)

# check for standard C/C++ include files
include(CheckIncludeFiles)
check_include_files("assert.h" HAVE_ASSERT_H)
check_include_files("limits.h" HAVE_LIMITS_H)
check_include_files("linux/limits.h" HAVE_LINUX_LIMITS_H)
check_include_files("malloc.h" HAVE_MALLOC_H)
check_include_files("math.h" HAVE_MATH_H)
check_include_files("stddef.h" HAVE_STDDEF_H)
check_include_files("stdint.h" HAVE_STDINT_H)
check_include_files("stdio.h" HAVE_STDIO_H)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("strings.h" HAVE_STRINGS_H)
check_include_files("string.h" HAVE_STRING_H)
check_include_files("sys/types.h" HAVE_SYS_TYPES_H)
check_include_files("unistd.h" HAVE_UNISTD_H)
check_include_files("windows.h" HAVE_WINDOWS_H)

# check for certain functions
include(CheckFunctionExists)
check_function_exists("bzero" HAVE_BZERO)

# check to see if rt library exists. If so, add -lrt to GA_EXTRA_LIBS
find_library(LIBRT rt PATHS /lib /usr/lib /usr/local/lib)
if (LIBRT)
  message(STATUS "VALUE OF LIBRT: ${LIBRT}")
#  if (CMX_EXTRA_LIBS)
#    set (CMX_EXTRA_LIBS "${CMX_EXTRA_LIBS} rt")
#  else()
#    set (CMX_EXTRA_LIBS rt)
#  endif()
#  set (CMAKE_REQUIRED_LIBRARIES "rt ${CMAKE_REQUIRED_LIBRARIES}")
#  message(STATUS "CMAKE_REQUIRED_LIBRARIES: ${CMAKE_REQUIRED_LIBRARIES}")
  list(APPEND CMX_EXTRA_LIBS rt)
else()
  message(STATUS "NO LIBRT FOUND")
endif()


# -------------------------------------------------------------
# figure out what BLAS library looks like
# -------------------------------------------------------------
if (NOT DEFINED ENABLE_BLAS)
option (ENABLE_BLAS "Include external BLAS" ON)
endif()
INCLUDE( CheckCSourceCompiles )
if (ENABLE_BLAS)
set (CMAKE_REQUIRED_LIBRARIES "blas ${CMAKE_REQUIRED_LIBRARIES}")
CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy (n,c1,ca,1,cb,1);
char daxpy_result = daxpy (n,d1,da,1,db,1);
char saxpy_result = saxpy (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy (n,z1,za,1,zb,1);
char ccopy_result = ccopy (n,c1,ca,1,cb,1);
char dcopy_result = dcopy (n,d1,da,1,db,1);
char scopy_result = scopy (n,s1,sa,1,sb,1);
char zcopy_result = zcopy (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_1_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy_ (n,c1,ca,1,cb,1);
char daxpy_result = daxpy_ (n,d1,da,1,db,1);
char saxpy_result = saxpy_ (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy_ (n,z1,za,1,zb,1);
char ccopy_result = ccopy_ (n,c1,ca,1,cb,1);
char dcopy_result = dcopy_ (n,d1,da,1,db,1);
char scopy_result = scopy_ (n,s1,sa,1,sb,1);
char zcopy_result = zcopy_ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_2_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = caxpy__ (n,c1,ca,1,cb,1);
char daxpy_result = daxpy__ (n,d1,da,1,db,1);
char saxpy_result = saxpy__ (n,s1,sa,1,sb,1);
char zaxpy_result = zaxpy__ (n,z1,za,1,zb,1);
char ccopy_result = ccopy__ (n,c1,ca,1,cb,1);
char dcopy_result = dcopy__ (n,d1,da,1,db,1);
char scopy_result = scopy__ (n,s1,sa,1,sb,1);
char zcopy_result = zcopy__ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_3_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY (n,d1,da,1,db,1);
char saxpy_result = SAXPY (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY (n,z1,za,1,zb,1);
char ccopy_result = CCOPY (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY (n,d1,da,1,db,1);
char scopy_result = SCOPY (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_4_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY_ (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY_ (n,d1,da,1,db,1);
char saxpy_result = SAXPY_ (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY_ (n,z1,za,1,zb,1);
char ccopy_result = CCOPY_ (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY_ (n,d1,da,1,db,1);
char scopy_result = SCOPY_ (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY_ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_5_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
typedef struct {float dummy[2];} SingleComplex;
typedef struct {double dummy[2];} DoubleComplex;
int n = 100;
SingleComplex c1,ca[100],cb[100];
double d1,da[100],db[100];
float s1,sa[100],sb[100];
DoubleComplex z1,za[100],zb[100];
char caxpy_result = CAXPY__ (n,c1,ca,1,cb,1);
char daxpy_result = DAXPY__ (n,d1,da,1,db,1);
char saxpy_result = SAXPY__ (n,s1,sa,1,sb,1);
char zaxpy_result = ZAXPY__ (n,z1,za,1,zb,1);
char ccopy_result = CCOPY__ (n,c1,ca,1,cb,1);
char dcopy_result = DCOPY__ (n,d1,da,1,db,1);
char scopy_result = SCOPY__ (n,s1,sa,1,sb,1);
char zcopy_result = ZCOPY__ (n,z1,za,1,zb,1);
return 0;
}
"
    BLAS_6_SIGNATURE )
endif()

# set blas symbols
if (BLAS_1_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy)
  set(CM_BLAS_DAXPY daxpy)
  set(CM_BLAS_SAXPY saxpy)
  set(CM_BLAS_ZAXPY zaxpy)
  set(CM_BLAS_CCOPY ccopy)
  set(CM_BLAS_DCOPY dcopy)
  set(CM_BLAS_SCOPY scopy)
  set(CM_BLAS_ZCOPY zcopy)
elseif (BLAS_2_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy_)
  set(CM_BLAS_DAXPY daxpy_)
  set(CM_BLAS_SAXPY saxpy_)
  set(CM_BLAS_ZAXPY zaxpy_)
  set(CM_BLAS_CCOPY ccopy_)
  set(CM_BLAS_DCOPY dcopy_)
  set(CM_BLAS_SCOPY scopy_)
  set(CM_BLAS_ZCOPY zcopy_)
elseif (BLAS_3_SIGNATURE)
  set(CM_BLAS_CAXPY caxpy__)
  set(CM_BLAS_DAXPY daxpy__)
  set(CM_BLAS_SAXPY saxpy__)
  set(CM_BLAS_ZAXPY zaxpy__)
  set(CM_BLAS_CCOPY ccopy__)
  set(CM_BLAS_DCOPY dcopy__)
  set(CM_BLAS_SCOPY scopy__)
  set(CM_BLAS_ZCOPY zcopy__)
elseif (BLAS_4_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY)
  set(CM_BLAS_DAXPY DAXPY)
  set(CM_BLAS_SAXPY SAXPY)
  set(CM_BLAS_ZAXPY ZAXPY)
  set(CM_BLAS_CCOPY CCOPY)
  set(CM_BLAS_DCOPY DCOPY)
  set(CM_BLAS_SCOPY SCOPY)
  set(CM_BLAS_ZCOPY ZCOPY)
elseif (BLAS_5_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY_)
  set(CM_BLAS_DAXPY DAXPY_)
  set(CM_BLAS_SAXPY SAXPY_)
  set(CM_BLAS_ZAXPY ZAXPY_)
  set(CM_BLAS_CCOPY CCOPY_)
  set(CM_BLAS_DCOPY DCOPY_)
  set(CM_BLAS_SCOPY SCOPY_)
  set(CM_BLAS_ZCOPY ZCOPY_)
elseif (BLAS_6_SIGNATURE)
  set(CM_BLAS_CAXPY CAXPY__)
  set(CM_BLAS_DAXPY DAXPY__)
  set(CM_BLAS_SAXPY SAXPY__)
  set(CM_BLAS_ZAXPY ZAXPY__)
  set(CM_BLAS_CCOPY CCOPY__)
  set(CM_BLAS_DCOPY DCOPY__)
  set(CM_BLAS_SCOPY SCOPY__)
  set(CM_BLAS_ZCOPY ZCOPY__)
else()
  set(CM_BLAS_CAXPY caxpy_)
  set(CM_BLAS_DAXPY daxpy_)
  set(CM_BLAS_SAXPY saxpy_)
  set(CM_BLAS_ZAXPY zaxpy_)
  set(CM_BLAS_CCOPY ccopy_)
  set(CM_BLAS_DCOPY dcopy_)
  set(CM_BLAS_SCOPY scopy_)
  set(CM_BLAS_ZCOPY zcopy_)
endif()

# check for weak alias pragma

CHECK_C_SOURCE_COMPILES(
"
extern void weakf(int c);
#pragma weak weakf = __weakf
void __weakf(int c) {}
int main(int argc, char **argv) {
  weakf(0);
  return(0);
}
"
   HAVE_SYS_WEAK_ALIAS_PRAGMA )

# Check for  FUNCTION_NAME

CHECK_C_SOURCE_COMPILES(
"
#include <stdio.h>
int sub(int i) {
  printf(\"%s\", __func__);
}
int main(int argc, char *argv[])
{
  sub(0);
  return 0;
}
"
    FUNCTION_1_SIGNATURE )

CHECK_C_SOURCE_COMPILES(
"
#include <stdio.h>
int sub(int i) {
  printf(\"%s\", __FUNCTION__);
}
int main(int argc, char *argv[])
{
  sub(0);
  return 0;
}
"
    FUNCTION_2_SIGNATURE )
if (FUNCTION_1_SIGNATURE)
  set(CM_FUNCTION_NAME __func__)
elseif(FUNCTION_2_SIGNATURE)
  set(CM_FUNCTION_NAME __FUNCTION__)
else()
  set(CM_FUNCTION_NAME __func__)
endif()

# check for availability of some functions
include(CheckFunctionExists)
CHECK_FUNCTION_EXISTS(sched_setaffinity
     HAVE_SCHED_SETAFFINITY)
CHECK_FUNCTION_EXISTS(pthread_setaffinity_np
     HAVE_PTHREAD_SETAFFINITY_NP)



# -------------------------------------------------------------

=== gaf2c/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

# -------------------------------------------------------------
# GAF2C header installation
# -------------------------------------------------------------

set(GAF2C_HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/farg.h  
  ${CMAKE_CURRENT_BINARY_DIR}/typesf2c.h
)

install (FILES
  ${GAF2C_HEADERS}
  DESTINATION include/ga
)

# -------------------------------------------------------------
# GAF2C library installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(FORTRAN_FILES gaf2c.c farg.F)
endif()

add_library(gaf2c OBJECT
  gaf2c.c
  testarg.c
  drand.c
  ${FORTRAN_FILES}
)

target_include_directories(gaf2c BEFORE PRIVATE 
                           #${CMAKE_CURRENT_SOURCE_DIR}
                           ${PROJECT_SOURCE_DIR}/comex/src-armci
                           ${PROJECT_BINARY_DIR}
                           ${CMAKE_CURRENT_BINARY_DIR}
)

if (ENABLE_FORTRAN)
  add_dependencies(gaf2c GenerateConfigFH)
endif()

=== contrib/marat/cluster/Makefile ===
#
# Makefile For Response/Local Potential Calculation
#
EXE     = cluster
SRCS = \
main.f smd_pdb.f
OBJS =$(SRCS:.f=.o)
${EXE}: $(OBJS) ;
	${FC} -o ${EXE} ${OBJS}

clean:
	rm -rf *.o cluster

=== contrib/marat/spectrum-improved/Makefile ===
EXE	= spectrum
SRCS = \
main.f
OBJS =$(SRCS:.f=.o)
${EXE}: $(OBJS) ;
	${FC} -o ${EXE} ${OBJS}

clean:
	rm -f *.o spectrum

=== debian/changelog ===
nwchem (7.2.2-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:00:53 +1100

nwchem (7.2.2-1build2) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:13:51 +0100

nwchem (7.2.2-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 20:33:31 +0000

nwchem (7.2.2-1) unstable; urgency=medium

  * New upstream release.
  * drop deprecated debian patches 13_armhf_noopt.patch and
    v721_PR889.patch
  * merge peigs parts of debian patches 02_makefile_flags.patch and
    08_lapack_constants_headers.patch into single patch
    peigs_defines.patch

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 Nov 2023 13:10:28 +0100

nwchem (7.2.1-4) unstable; urgency=medium

  * update debian patch 02_makefile_flags.patch
    - add alpha to the no-m64 set
    - don't add LINUX64 to the LINUX (32-bit) block
      Enable a proper 64-bit configuration as intended upstream.
    - re-enable upstream's LINUXCPU definitions in config/makefile.h
  * debian/rules: set USE_HWOPT=n to avoid chip-specific optimisations
    e.g. no i786 instructions in the i386 build. Used by makefile.h.
    Needed after enabling LINUXCPU in makefile.h
  * debian patch 32bit_overflow_n2_ccsd_2824153.patch applies upstream
    commit 2824153 to fix n2_ccsd SIGFPE on 32 bit machines

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Oct 2023 00:15:16 +0200

nwchem (7.2.1-3) unstable; urgency=medium

  * 02_makefile_flags.patch: mark loong64 (loongarch64) as not
     supporting -m64 (set DONTHAVEM64OPT=y)
  * debian patch v721_PR889.patch applies upstream PR#889 to update
    internal version to 7.2.1

 -- Drew Parsons <dparsons@debian.org>  Wed, 18 Oct 2023 13:02:20 +0200

nwchem (7.2.1-2) unstable; urgency=medium

  * update debian patches
    - 02_makefile_flags.patch: switch off -m64 flag for ia64
    - ga_libs.patch: add handling for GA_INCLUDE_PATH to
      allow for the GA include dir in a separate location from
      EXTERNAL_GA_PATH (debian uses /usr i.e. /usr/include)
      GA include files (ga-wapi.h) are used by ccsd and nwdft/xc

 -- Drew Parsons <dparsons@debian.org>  Wed, 11 Oct 2023 01:36:20 +0200

nwchem (7.2.1-1exp1) experimental; urgency=medium

  * New upstream release.
    - deprecates debian patch test_ch5n_nbo_Issue864.patch
  * reconfigure debian patch 02_makefile_flags.patch
    - use upstream's _CPU, which sets -m64 via DONTHAVEM64OPT
      (enables build on riscv64)
    - use gfortran with standard build flags for ia64
      (upstream uses Intel's ifort)
    - mark deactivated variables with _not_debian
      (e.g. LINUXCPU_not_debian) to make Debian-specific build
      configuration changes clear
  * debian/rules: use the parallel option in DEB_BUILD_OPTIONS
    to run the build in parallel (make -j)
    - update 02_makefile_flags.patch to drop the linux default
      setting -j 1 in MAKEFLAGS
  * update debian/watch to uscan version 4.
    Configure to access the full source tarball as recommended by
    upstream (nwchem-VERSION@release*-src.*) rather than the github
    tagged tarball.

 -- Drew Parsons <dparsons@debian.org>  Fri, 06 Oct 2023 23:40:30 +0200

nwchem (7.2.0-1exp1) experimental; urgency=medium

  * New upstream release
    - applies debian patch fix_py310_6384013.diff
    - Build-Depends: bc
  * add Drew Parsons as uploader
  * convert debian/copyright to machine-readable format.
    Still licensed under the Educational Community License, Version 2.0
  * maintain local copy of DFT-D3 source at debian/dftd3/dftd3.tgz
    (GPL licence). The nwchem build normally downloads dftd3 at build
    time, but internet access is forbidden at build-time by Debian
    policy, hence a local copy is needed. Used by NWPW (XC)
    i.e. src/nwpw/nwpwlib/nwpwxc
    Downloaded from
    https://www.chemiebn.uni-bonn.de/pctc/mulliken-center/software/dft-d3/
    DFT-D3 status documented in debian/README.source.
  * lintian fixes
    - drop -X-Python-Version and Build-Depends: autotools-dev
      from debian/control
    - use dpkg-architecture conditionally (?=) in debian/rules
    - fix GPL-3 entry in debian/copyright
    - update lintian overrides (nwchem-data)
  * drop Build-Depends: csh and convert debian/testsuite to bash.
    Some scripts in the source tarball still use csh, but not the ones
    used by the debian build (e.g. QA/runtests.mpi.unix)
    Thanks Edoardo Apra. Closes: #998401.
  * debian patch test_ch5n_nbo_Issue864.patch patches the ch5n_nbo test
    with DIRECT to enable the SCF energy to pass tolerance (otherwise
    the energy differs by 1e-5 Hartree). See upstream Issue #864.

 -- Drew Parsons <dparsons@debian.org>  Fri, 29 Sep 2023 11:57:34 +0200

nwchem (7.0.2-5) unstable; urgency=medium

  * Team upload.
  * debian patch fix_py310_6384013.diff applies upstream commit
    6384013 to build with python3.10 and higher.
  * Build with set -e so as not to continue build if there are failures.
    Closes: #1042034
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Wed, 20 Sep 2023 02:33:05 +0200

nwchem (7.0.2-4) unstable; urgency=medium

  * Team upload.
  * create nwchem-mpich.README.Debian to document the need to use
    ARMCI_USE_WIN_ALLOCATE=0 when running nwchem with MPICH 4.0.2
    (binary nwchem.mpich, fixed in mpich 4.0.3).
    See upstream Issue#633.

 -- Drew Parsons <dparsons@debian.org>  Sun, 19 Mar 2023 15:01:42 +0100

nwchem (7.0.2-3) unstable; urgency=medium

  * Team upload.
  * upload nwchem-mpich to unstable

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Mar 2022 17:20:23 +0100

nwchem (7.0.2-2) experimental; urgency=medium

  [ Andrius Merkys ]
  * Team upload.
  * Adjusting debian/watch to changes in URL scheme.

  [ Edoardo Apra ]
  * Website moved to GitHub.

  [ Drew Parsons ]


=== debian/control ===
Source: nwchem
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
 Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               gfortran,
               bc,
               libarmci-mpi-dev (>= 0.3.1~beta-2~),
               libblas-dev,
               libglobalarrays-dev (>= 5.8.1-4~),
               liblapack-dev,
               libscalapack-mpi-dev (>= 2),
               libscalapack-mpich-dev (>= 2),
               libscalapack-openmpi-dev (>= 2),
               mpi-default-bin,
               mpi-default-dev,
               libmpich-dev,
               libopenmpi-dev,
               openssh-client,
               pkg-config,
               python3-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://nwchemgit.github.io
Vcs-Browser: https://salsa.debian.org/debichem-team/nwchem
Vcs-Git: https://salsa.debian.org/debichem-team/nwchem.git

Package: nwchem
Architecture: all
Depends: ${nwchem:Depends},
         mpi-default-bin,
         ${misc:Depends}
Description: High-performance computational chemistry software (default MPI)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.
 .
 This package provides example input scripts and depends on nwchem built for
 the default MPI implementation for the architecture.
 .
 The default MPI is openmpi for most debian systems. OpenMPI has known problems
 running nwchem over multiple nodes. If you need to compute large molecules
 using cluster computation, you may want to use the MPICH build provided by
 nwchem-mpich instead.

Package: nwchem-openmpi
Architecture: any
Multi-Arch: allowed
Depends: openmpi-bin,
         nwchem-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: High-performance computational chemistry software (OpenMPI build)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.
 .
 This package provides nwchem built with OpenMPI.
 .
 OpenMPI has known problems running nwchem over multiple nodes. If you need
 to compute large molecules using cluster computation, you may want to use
 the MPICH build provided by nwchem-mpich instead.

Package: nwchem-mpich
Architecture: any
Multi-Arch: allowed
Depends: mpich,
         nwchem-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: High-performance computational chemistry software (MPICH build)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(filter checkall,$(DEB_BUILD_OPTIONS)))
export RUN_ALL_TESTS ="yes"
endif

include /usr/share/mpi-default-dev/debian_defaults

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS = 1
endif

# generic debian package builds don't use chip-specific optimisations
# e.g. don't use i786 instructions in the i386 build
export USE_HWOPT=n

ifeq ($(DEB_HOST_ARCH_BITS),64)
export NWCHEM_TARGET=LINUX64
export USE_64TO32="yes"
else
export NWCHEM_TARGET=LINUX
endif
export BLAS_SIZE=4
export BLAS_LIB="-lblas"
export LAPACK_LIB="-llapack"
export USE_SCALAPACK="yes"
export SCALAPACK_SIZE=4
export NWCHEM_MODULES="pnnl"
export NWCHEM_LONG_PATHS="y"
export PYTHONVERSION=$(shell py3versions -dv)
export PYTHONHOME=$(shell python3-config --prefix)
export LARGE_FILES=TRUE
export FC=gfortran
export USE_MPI="y"
export USE_MPIF="y"
export USE_MPIF4="y"
export MPI_LIB=/usr/lib
LIBMPI_MPICH="$(shell for w in `mpifort.mpich -show`; do if [ "x$${w%$${w#??}}" = "x-L" -o "x$${w%$${w#??}}" = "x-l" ]; then echo -n "$$w "; fi; done)"
LIBMPI_OPENMPI="$(shell pkg-config ompi-fort --libs)"
ifneq (,$(filter ccsdtq,$(DEB_BUILD_OPTIONS)))
export CCSDTQ="yes"
endif
ifneq (,$(filter ccsdtlr,$(DEB_BUILD_OPTIONS)))
export CCSDTLR="yes"
endif
export MRCC_METHODS=y
export IPCCSD=y
export EACCSD=y
export HAS_BLAS="yes"
export BLASOPT=-lblas -llapack
export ARMCI_NETWORK=SOCKETS
export USE_ARUR="yes"

%:
	dh $@ --with python3

execute_before_dh_auto_configure:
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi
	tmpdir=`mktemp -d`; \
	cp -ra $(CURDIR)/* $${tmpdir}; \
	cp debian/dftd3/dftd3.tgz $${tmpdir}/src/nwpw/nwpwlib/nwpwxc; \
	mv $$tmpdir $(CURDIR)/pristine-src
	cp -ra pristine-src build-mpich
	cp -ra pristine-src build-openmpi

override_dh_auto_build-arch:
	set -e; \
	for mpi_flavor in mpich openmpi; do \
	  if [ "x$${mpi_flavor}" = "xmpich" ]; then \
	    export LIBMPI=$"$(LIBMPI_MPICH)$"; \
	    export LDFLAGS="$${LDFLAGS} -pthread"; \
	  else \
	    export LIBMPI=$"$(LIBMPI_OPENMPI)$"; \
	  fi; \
	  echo "building nwchem against $${mpi_flavor}"; \
	  echo "using LIBMPI=$${LIBMPI}"; \
	  export NWCHEM_TOP=$(CURDIR)/build-$${mpi_flavor}; \
	  export MPICC=mpicc.$${mpi_flavor}; \
	  export MPICXX=mpicxx.$${mpi_flavor}; \
	  export MPIF77=mpif77.$${mpi_flavor}; \
	  export MPIFC=mpifort.$${mpi_flavor}; \
	  export MPIF90=mpif90.$${mpi_flavor}; \
	  export MPI_INCLUDE=/usr/include/$(DEB_HOST_MULTIARCH)/$${mpi_flavor}; \
	  export MPIRUN_PATH=/usr/bin/mpirun.$${mpi_flavor}; \
	  export SCALAPACK=-lscalapack-$${mpi_flavor}; \
	  export BLACS=-lscalapack-$${mpi_flavor}; \
	  export EXTERNAL_GA_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/ga/$${mpi_flavor}; \
	  export GA_INCLUDE_PATH=/usr; \
	  export LIBDIR=$${NWCHEM_TOP}/lib/$(NWCHEM_TARGET); \
	  mkdir -p $${NWCHEM_TOP}/bin/$${NWCHEM_TARGET}; \
	  (cd $${NWCHEM_TOP}/src && NWCHEM_TOP=$${NWCHEM_TOP} make -j $(NUMJOBS) nwchem_config); \
	  if [ "x$(DEB_HOST_ARCH_BITS)" = "x64" ]; then \
	    (cd $${NWCHEM_TOP}/src && make -j $(NUMJOBS) 64_to_32) ; \
	    find $${NWCHEM_TOP}/src -name include_stamp | xargs rm -f; \
	    find $${NWCHEM_TOP}/src -name dependencies | xargs rm -f; \
	  fi; \
	  (cd $${NWCHEM_TOP}/src && make -j $(NUMJOBS)); \
	  (cd $${NWCHEM_TOP}/src/util && make -j $(NUMJOBS)); \
	  (cd $${NWCHEM_TOP}/src && make -j $(NUMJOBS) link); \
	  if [ "x$(DEB_HOST_ARCH_BITS)" = "x64" ]; then \
	    (cd $${NWCHEM_TOP}/src && make -j $(NUMJOBS) 32_to_64); \
	  fi; \
	  cp $${NWCHEM_TOP}/bin/$(NWCHEM_TARGET)/nwchem $${NWCHEM_TOP}/bin/$(NWCHEM_TARGET)/nwchem.$${mpi_flavor}; \
	done

override_dh_auto_clean:
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi
	dh_testdir
	-(cd $(CURDIR)/src && make -j $(NUMJOBS) realclean)
	-(cd $(CURDIR)/doc && make -j $(NUMJOBS) realclean)
	rm -rf $(CURDIR)/bin $(CURDIR)/lib $(CURDIR)/src/tools/lib 
	rm -rf $(CURDIR)/QA/scratchdir $(CURDIR)/QA/testoutputs
	rm -f src/util/util_version.F src/stubs.F src/util/util_module_avail.F src/util/util_nwchem_version.F
	find $(CURDIR) -name "*.stamp" | xargs rm -f
	dh_auto_clean
	rm -f src/config/NWCHEM_CONFIG src/config/nwchem_config.h


override_dh_auto_test:
	dh_testdir
	-for mpi_flavor in mpich openmpi; do \
	  export NWCHEM_TOP=$(CURDIR)/build-$${mpi_flavor}; \
	  export NWCHEM_BASIS_LIBRARY=$${NWCHEM_TOP}/src/basis/libraries/; \
	  export NWCHEM_NWPW_LIBRARY=$${NWCHEM_TOP}/src/nwpw/libraryps/; \
	  export RUNTESTS=$${NWCHEM_TOP}/QA/runtests.mpi.unix; \
	  export NWCHEM_EXECUTABLE=$${NWCHEM_TOP}/bin/$(NWCHEM_TARGET)/nwchem}; \
	  (cd $(CURDIR)/build-$${mpi_flavor}/QA && if [ "$(RUN_ALL_TESTS)" = "yes" ]; then \
	   ../debian/testsuite all; else ../debian/testsuite; fi); \
	done

execute_after_dh_link:
	dh_link -pnwchem usr/bin/nwchem.$(ARCH_DEFAULT_MPI_IMPL) usr/bin/nwchem

override_dh_gencontrol:
	dh_gencontrol -- -Vnwchem:Depends="nwchem-$(ARCH_DEFAULT_MPI_IMPL) | nwchem-mpich | nwchem-openmpi"

=== debian/tests/control ===
Depends: nwchem,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite.sh
Restrictions: allow-stderr

Depends: nwchem-openmpi,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite-openmpi
Restrictions: allow-stderr

Depends: nwchem-mpich,
 libopenblas-dev | libatlas-base-dev | libblis-dev | libblas3 | libblas.so.3,
 libopenblas-dev | libatlas-base-dev | liblapack3 | liblapack.so.3
Tests: testsuite-mpich
Restrictions: allow-stderr
